#ifndef MENUE_CORE_
#define MENUE_CORE_

#ifndef NULL
#define NULL    ((void *)0)
#endif

#ifndef False
#define False   (0)
#endif

#ifndef True
#define True    (1)
#endif


#define SELECTED 		0x01//(u8_t)(1<<1)
#define SELECTABLE 		0x02//(u8_t)(1<<2)
#define VISIBLE			0x04//(u8_t)(1<<3)


typedef unsigned char u8_t;
typedef   signed char i8_t;
typedef unsigned short u16_t;
typedef   signed short i16_t;


/**
 * @brief Datenstruktur fr ein Icon Object
 * @param width Icon Breite in Pixel
 * @param heigt Icon Hhe in Pixel
 * @param data Pointer auf Icon Daten TODO:Definieren Icon Data
 */
typedef struct menueIcon{
	
	u8_t width;
	u8_t height;
	u8_t colorDepth; // Farbtiefe 1, 8, 256 Bit-Farben
	u8_t *data;	//Byte fr Byte Daten fr Icon ?

}MenueIcon;


/**
 * @brief Datenstruktur fr ein MenueItem Object
 * @param menueIcon Icon
 * @param text Name des Menuepunktes -> linksbndig
 * @param value Falls ein Wert dargestellt werden mchte -> rechstbndig 
 * @param flags ->TODO:Flags Definieren wie selected, visible.. usw
 * @param next nchster Item
 * @param prev vorheriger Item
// * @param parent Vater Item
// * @param child Kind Item 
 */
typedef struct menueItem{

	struct menueIcon *menueIcon; //Icon zum Beispiel Batterie-Symbol
	const char *text;
	char *value; 
	u8_t flags;
    struct menueItem *next;
    struct menueItem *prev;
    struct menueItem *parent;
    struct menueItem *child;

}MenueItem;


extern struct menueItem *getRoot(void);


#endif /*MENUE_CORE_*/

