
#include "menue.h"
#include "menue_core.h"

#include "graphics.h"
#include "font.h"

#include "main.h"
#include "mtutil.h"

static volatile MenueItem *myMenue; // definiert den Zeiger auf die akteulle Menliste 
static volatile MenueItem *selectedItem; // aktuell selektierter Item

static void DrawMenuItem(MenueItem *Item, int posY);
static void DrawMenuList(MenueItem *ItemList);

static void ProcessMenuList(MenueItem *ItemList, MenueItem *SelItem);



void initMenue(void)
{
	myMenue = getRoot();
    selectedItem = myMenue;
    
    DrawMenuList(myMenue);    
}

void DrawMenuItem(MenueItem *Item, int posY)
{
	if (Item !=NULL)
	{		
        if(Item->flags & VISIBLE)
		{
            setY(posY+1);
            
            setX(getX()+2);
            putString(Item->text);
            setX(getX()-2);
            
            if((Item->flags & (SELECTED)))
            {
                rectangle(getX(),posY,127,posY+10);
                setX(0);
            }   
		}
	}
}

// Zeichne eine gesamte Menliste
void DrawMenuList(MenueItem *ItemList)
{	
	int posY = 0;
	MenueItem *list;
	
	if (ItemList != NULL)
	{
		list = ItemList;
		
        clrScr(0);
        
		while (list != NULL)
		{
			DrawMenuItem(list,posY);
			posY += 12;
			list = list->next;			
		}
	}
}

/* So funktioniert es wenn ich mit dem globalen Zeiger Arbeite 
void ProcessMenuList(MenueItem *ItemList, MenueItem *SelItem)//, unKeys)
{
    // select next Item
    if(get_key_press(DOWN))   
	{
        selectedItem->flags &= ~(SELECTED); //delete flag from actual item
        
        while(((selectedItem->next->flags) & SELECTABLE) == 0)
        { 
            //setSelectedItem(SelItem->next); // so geht es.
            selectedItem = selectedItem->next;//->next;  // geht nicht. 
        }
        
        //SelItem->next->flags = SelItem->next->flags | SELECTED;
        selectedItem->next->flags = selectedItem->next->flags | SELECTED;
        
        DrawMenuList(ItemList);  // und zeichne die aktuelle Menliste
        
        selectedItem = selectedItem->next;//->next;  // geht nicht. 
        
        //setSelectedItem(SelItem->next);       
		//DrawMenuList(ItemList); // last but not least draw actual list      
	} 
*/

/*So funtkioniert es nicht bei jedem Aufruf von ProcessMenuList ist SelItem auf dem alten Wert
 * SelItem = SelItem->next wird ignoriert wiso? */
void ProcessMenuList(MenueItem *ItemList, MenueItem *SelItem)//, unKeys)
{
    //Select next Item
    if(get_key_press(DOWN))   
    {
        SelItem->flags &= ~(SELECTED); //Delete flag from actual item
        
        SelItem = SelItem->next; //Zeil wird nicht bernommen bzw. bei neum Aufruf nich erkennbar
        
        while(((SelItem->flags) & SELECTABLE) == 0)
        { 
            SelItem = SelItem->next;
        }
        
        SelItem->flags = SelItem->flags | (SELECTED); //Set new Selected Item as SELECTED
        
        
        DrawMenuList(ItemList);  //Zeichne die aktuelle Menliste
    } 

    
    /*
	else
	if ((Keys & evKeyUp) != 0)
	{
		// hnl. wie vorher
		SelItem = SelItem->Prev;	
		// hnl. wie vorher
	}
	else
	if (Keys & evKeyEnter) !=0)
	{
		SelItem = SelItem.Child;
	}	
    */
}


void processMenu(void)
{
    ProcessMenuList(myMenue, selectedItem);

}


